{ ****************************************************************
  Sourcefile :  	bankData.pas
  Typ :  		Entity-Unit
  Autor :  		max kleiner, LoC=448
  Beschreibung :  	manages dataaccess in SQL / fileaccess				fgung
  Klassen :	  	siehe ModelMaker
  Besonderes : 	        kooperiert mit bankControll
  Revisionen :  	07.11.99 mit Basisklassen der Queries
			02.02.00 before and after methods
                        05.06.04 join to get customer data
 **************************************************************** }

unit bankData;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs,
  DBTables, Db;

type
  TDataModule1 = class(TDataModule)
    Database1: TDatabase;
    q_TransHist: TQuery;
    q_summe: TQuery;
    q_Data: TQuery;
    dsOpen: TDataSource;
    dSrcCust: TDataSource;
    dSrcAccType: TDataSource;
    dSrcAccount: TDataSource;
    dSrcTransHist: TDataSource;
    tblCust: TTable;
    tblAccount: TTable;
    tblAcctype: TTable;
    sp_AType_ID: TStoredProc;
    SP_Acc_ID: TStoredProc;
    SP_Trans: TStoredProc;
    SP_Cust_ID: TStoredProc;
    tblCustCUST_NO: TIntegerField;
    tblCustCUSTOMER: TStringField;
    tblAccountACC_NO: TIntegerField;
    tblAccountCUST_NO: TIntegerField;
    tblAccountACC_TYPE: TSmallintField;
    tblAcctypeACC_ID: TSmallintField;
    tblAcctypeDESCRIPT: TStringField;
    tblAcctypeMUTDATE: TDateTimeField;
    tblCustMUTDATE: TDateTimeField;
    tblAccountMUTDATE: TDateTimeField;
    tblCustCONTACT_FIRST: TStringField;
    tblCustADDRESS_LINE1: TStringField;
    tblCustCITY: TStringField;
    tblAccountAMOUNT: TFloatField;
    tblAccountLIMIT: TFloatField;
    tblAccountFEE: TFloatField;
    procedure tblCustNewRecord(DataSet: TDataSet);
    procedure tblAcctypeNewRecord(DataSet: TDataSet);
    procedure tblAccountNewRecord(DataSet: TDataSet);
    procedure DataModule1Create(Sender: TObject);
  private
    { Private declarations }
    //procedure DisposeDataMem(var BufferX; Size: Integer);
  public
    { Public declarations }
  end;

 TBusObj = class(TDataModule1)
 // subclassing the TDataModule
  //q_Data: TQuery;
 protected
   procedure getSQLKonto(const custNo: longint;
                               const accTyp: byte);
   procedure setSQLKonto(const acc_No: longint);
   procedure setSQLTransData(betrag: double; accNo: longint);
   procedure setSP_TransData(betrag: double; accNo: longint);
   function getSQLUmsatz(custNo: longint;
                          accNo: longint): double;
   //procedure transInsert(dataSet: TDataSet); virtual;
   procedure dataBeforeEdit(dataSet: TDataSet); virtual;
   procedure dataBeforePost(dataSet: TDataSet); virtual;
   procedure dataAfterPost(dataSet: TDataSet); virtual;
   procedure dataBeforeDelete(dataSet: TDataSet); virtual;
   procedure dataAfterCancel(dataSet: TDataSet); virtual;
 private
   custList: TStringList;
   seekStr: string[255];
   procedure loadMasterBase;
   procedure setStoredProcedures;
 public
   constructor createBusObj;
   destructor Destroy; override;
   procedure getSQLTransHist(custNo: longint; accTyp: byte);
   function getAllCustNo: TStringList;
   function getAllVermoegen(custNo: longint): double;
   procedure writeToFile(kList: TStringList);
   function readFromFile(rList: TStringList): TStringList;
   function getStreamTemplate(rList: TStringList): TStringList;
 end;


var
// wird von bankControll instanziert
  dataModule1: TDataModule1;
       busObj: TBusObj;

implementation
uses ufilexport, ulooktrans;

{$R *.DFM}


procedure TDataModule1.DataModule1Create(Sender: TObject);
begin
 (* with dataBase1 do begin
    LoginPrompt:=false;
    connected:=true;
    end; *)
  busObj.loadMasterBase;
  busObj.setStoredProcedures;
end;


constructor TBusObj.createBusObj;
//hier datenbank-abhaengige business rules
 var i: integer;
   locdatabase: string[255];

 begin
   inherited;

     locdatabase:= 'umlbank';
     //for i:= 1 to components.count - 1 do begin

   // and (TcwEdit(components[i]).FImport<>Nil) then
     //Dispose(PtrImp(TcwEdit(components[i]).FImport));

     custList:= TStringList.create;
    // something to change in datamodule
   end;

destructor TBusObj.Destroy;
  begin
    custList.free;
    inherited Destroy;
  end;

procedure TBusObj.setStoredProcedures;
begin
  with dataModule1 do begin
    tblCust.onNewRecord:= tblCustNewRecord;
    tblAcctype.onNewRecord:= tblAcctypeNewRecord;
    tblAccount.onNewRecord:= tblAccountNewRecord;
  end;
end;

procedure TBusObj.loadMasterBase;
var i: integer;
begin
  with dataModule1 do begin

    //  with Sender do

    try
      with Database1 do begin
        Connected:= false;
        AliasName:= DB_ALIAS;
        DatabaseName:= DB_NAME;
        connected:= true;
        keepConnection:= true;
      end;
   //database1.AliasName:= 'UML_Bank';
   //database1.DatabaseName:= locdatabase;

   for i:=0 to datamodule1.componentcount-1 do begin
    if (components[i] is TTable) then
      TTable(components[i]).DatabaseName:= DB_Name;
    if (components[i] is TQuery) then
      TQuery(components[i]).DatabaseName:= DB_Name;
    end;


      tblCust.active:= true;
      dSrcCust.dataSet:= tblCust;
      tblAcctype.active:= true;
      dSrcAccType.dataSet:= tblAcctype;
      tblAccount.active:= true;
      dSrcAccount.dataSet:= tblAccount;
    except
      on EDataBaseError do
       raise EDatabaseError.Create(frmTrans.strLit[19]);
    end;
  end;
 end;


function TBusObj.getAllCustNo: TStringList;
 begin
   with dataModule1.dSrcCust do begin
     dataSet.first;
     while not dataSet.EOF do begin
       custList.add(dataSet.fieldValues['CUST_NO']);
       dataSet.next;
     end;
   end;
  result:= custList;
 end;


function TBusObj.getAllVermoegen(custNo: integer): double;
 begin
 seekStr:='';
 seekStr:='SELECT SUM(amount) as TOTAL FROM ACCOUNT ' +
                  'WHERE CUST_NO =:NUMB ';
  with dataModule1.q_summe do begin
    try
      close;
      SQL.Clear;
      SQL.Add(seekStr);
      paramByName('NUMB').value:= IntToStr(custNo);
      open;
    except
     on EDatabaseError do
      showmessage(frmTrans.strLit[42]);
    end;
   result:= fieldByName('TOTAL').asFloat;
  end;
 end;


procedure TBusObj.getSQLKonto(const custNo: longint;
                                   const accTyp: byte);
begin
 seekStr:='';
 seekStr:='SELECT * FROM CUSTOMER, ACCOUNT WHERE '+
            'ACCOUNT.CUST_NO = CUSTOMER.CUST_NO '+
            'AND CUSTOMER.CUST_NO = :NUMB '+
            'AND ACCOUNT.ACC_TYPE = :ACC';
  try
   with dataModule1.q_data do begin
     close;
     SQL.Clear;
     SQL.Add(seekStr);
     paramByName('NUMB').value:= IntToStr(custNo);
     paramByName('ACC').value:= IntToStr(accTyp);
     requestLive:= false;
     open;
    //to get a join reqlive is false, save data reqlive is true
     requestLive:= true;
   end;
  except
    on EDatabaseError do begin
      showmessage(frmTrans.strLit[41]);
     end;
    //dataModule1.q_data.free;
  end;
end;

procedure TBusObj.setSQLKonto(const acc_No: longint);
begin
 seekStr:='';
 seekStr:='SELECT * FROM ACCOUNT WHERE ACC_NO = :NUMB';
 with dataModule1.q_data do begin
    close;
    SQL.Clear;
    SQL.Add(seekStr);
    paramByName('NUMB').value:= acc_No;
    open;
   end;
 end;

procedure TBusObj.setSQLTransData(betrag:double; accNo:longint);
begin
 with dataModule1.q_TransHist do begin
   try
     Close;
     SQL.Clear;
     SQL.Add('INSERT INTO TRANS1(TRANSAMOUNT, ACC_NO, OPENDATE)');
     SQL.Add('VALUES (:betrag, :accNo, :date)');
     Params[0].AsFloat:= betrag;
     Params[1].AsInteger:= accNo;
     Params[2].asDateTime:= NOW;
     //no resulset
     ExecSQL;
   except
      dataModule1.q_TransHist.free;
   end;
 end;
end;

procedure TBusObj.setSP_TransData(betrag: double; accNo: longint);
begin
 with dataModule1.SP_Trans do begin
   Params[0].asfloat:= betrag;
   Params[1].asinteger:= accNo;
   Params[2].asDateTime:= NOW;
   Prepare;
   ExecProc;
 end;
end;


procedure TBusObj.getSQLTransHist(custNo: longint; accTyp: byte);
begin
 seekStr:='';
 seekStr:='SELECT TRANS_ID, ACC_NO, TRANSAMOUNT, OPENDATE FROM ' +
          'TRANS1, ACCOUNT WHERE ACCOUNT.ACC_NO = TRANS1.ACC_NO '+
          'and ACCOUNT.CUST_NO = :NUMB '+
          'and ACCOUNT.ACC_TYPE = :ACC';
 with dataModule1.q_transHist do begin
   close;
   SQL.Clear;
   SQL.add(seekStr);
   paramByName('NUMB').value:= custNo;
   paramByName('ACC').value:= accTyp;
  //ParamByName('beginDate').AsDateTime:=beginDate;
   requestLive:=false;
   open;
 end;
end;

function TBusObj.getSQLUmsatz(custNo: longint; accNo: longint):
                                                      double;
begin
 seekStr:='';
 seekStr:='SELECT sum(TRANSAMOUNT) as UMSATZ from TRANS1, ACCOUNT ' +
          'WHERE ACCOUNT.ACC_NO = TRANS1.ACC_NO '+
          'and ACCOUNT.CUST_NO = :NUMB '+
          'and ACCOUNT.ACC_NO = :ACC '+
          'AND cast(cast(OPENDATE as char(11))as DATE)= ''TODAY''';
 with dataModule1.q_transHist do begin
   Close; SQL.Clear;
   SQL.add(seekStr);
   paramByName('NUMB').value:= custNo;
   paramByName('ACC').value:= accNo;
   Open;
  result:= fieldByName('UMSATZ').asFloat;
 end;
end;


 procedure TBusObj.dataBeforeEdit(dataSet: TDataSet);
 begin
  //put code here to place an optimistic lock
 end;

 procedure TBusObj.dataBeforePost(dataSet: TDataSet);
 begin
  //check the optimistic lock
  //dataSet.post;
   dataModule1.dsOpen.dataSet.edit;
   dataModule1.dsOpen.dataSet.fieldvalues['MUTDATE']:=Now;
 end;

 procedure TBusObj.dataAfterPost(dataSet: TDataSet);
 begin
  //release optimistick lock
   dataModule1.dsOpen.dataSet.post;
 end;
 procedure TBusObj.dataBeforeDelete(dataSet: TDataSet);
 begin
  //check the optimistic lock for contentions
 end;

 procedure TBusObj.dataAfterCancel(dataSet: TDataSet);
 begin
  //relase out optimistic locks
 end;

 procedure TBusObj.writeToFile(kList: TStringList);
 var qf : TTxtFile;
      i: integer;
 begin
 //constructor
   qf:= TTxtFile.Create(uFILENAME);
   qf.ReWrite;
   try
     if kList.count > 0 then
       for i:= 0 to kList.count -1 do
               qf.Writeln(kList.strings[i]);
   finally
     qf.Close;
     qf.Free
   end;
 end;

function TBusObj.readFromFile(rList: TStringList): TStringList;
var qa: TTxtFile;
     tmpString: String;
 begin
   qa:= TTxtFile.create(uFILENAME);
   qa.ReSet;
   try
     while not qa.Eof do begin
       qa.Readln(tmpString);
       rList.add(tmpString);
     end;
     result:= rList;
   finally
    qa.Close;
    qa.Free;
   end
 end;


// template pattern
function TBusObj.getStreamTemplate(rList: TStringList):
                                             TStringList;
var
  M: TMemoryStream;
  S: TStringStream;
begin
  M:= TMemoryStream.Create;
  S:= TStringStream.Create('');
  try
    M.LoadFromFile(ExtractFilePath(Application.ExeName)+SYSFILE);
    M.Seek(0,0);
      // TStream.CopyFrom() method uses WriteBuffer() and ReadBuffer() template methods
      // that in turn call Read() and Write(), which are the abstract methods that must
      // be implemented by derived classes: TCustomMemoryStream and TStringStream
    S.CopyFrom(M, M.Size);
    S.Seek(0,0);
    with rList do begin
      Clear;
      add(frmTrans.strLit[43]);
      rList.addStrings(TStringList(frmTrans.getFileList
           (ExtractFilePath(Application.ExeName)+'IB_BANK\*.*')));
      add(' ');
      Add(S.ReadString(S.Size));
    end;
    result:= rList;  //back to caller
  finally
    M.Free;
    S.Free;
  end;
end;

procedure TDataModule1.tblCustNewRecord(DataSet: TDataSet);
begin
  with sp_cust_id do begin
   //SP returns the ID
    execproc;
    tblCustCUST_NO.value:= params[0].value;
    tblCustMUTDATE.value:= Now;
   end;
end;

procedure TDataModule1.tblAcctypeNewRecord(DataSet: TDataSet);
begin
  with sp_aType_id do begin
    execproc;
    tblAcctypeACC_ID.value:= params[0].value;
    tblAcctypeMUTDATE.value:= Now;
  end;
end;

procedure TDataModule1.tblAccountNewRecord(DataSet: TDataSet);
begin
  with sp_Acc_id do begin
    execproc;
    tblAccountACC_No.value:= params[0].value;
    tblAccountMUTDATE.value:= Now;
  end;
end;

{procedure TDataModule1.DisposeDataMem(var BufferX; Size: Integer);
begin
  if Pointer(BufferX) <> NIL then begin
    FreeMem(Pointer(BufferX), Size);
    Pointer(BufferX):= NIL;
  end;
end;}


end.
