{ ****************************************************************
  Sourcefile :  	bankView.pas
  Typ :  		Boundary-Unit
  Autor :  		max kleiner
  Beschreibung :  	shows the mainform				fgung
  Klassen :	  	4, siehe ModelMaker
  Besonderes : 	        uses an activeX :VtChart
  Revisionen :  	07.11.99 main design
                        05.06.04 copy to clipboard, LoC=573
 **************************************************************** }

unit bankView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, bankControll,
  vcfi, VCIFiLib_TLB, OleCtrls;

type

  TProgBars = class;  //forward
  TBMonitor = class;

 TfrmBank = class(TForm)
    memBank: TMemo;
    btnShowKonto: TButton;
    btnKreditLimit: TButton;
    edtBetrag: TEdit;
    btnOpen: TButton;
    btnBuchen: TButton;
    lblKNummer: TLabel;
    lblMemo: TLabel;
    btnUmsatz: TButton;
    lblMess: TLabel;
    rGrp: TRadioGroup;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    imgWorld: TImage;
    PopupMenu1: TPopupMenu;
    saveReport1: TMenuItem;
    saveKonto1: TMenuItem;
    readFile1: TMenuItem;
    ErzeugenReport1: TMenuItem;
    MainMenu1: TMainMenu;
    Kundendaten1: TMenuItem;
    Kontoarten1: TMenuItem;
    Kundendaten2: TMenuItem;
    Gebuehren1: TMenuItem;
    Jahresgebuehr1: TMenuItem;
    saveBank1: TMenuItem;
    saveKontoBank1: TMenuItem;
    Depotgebuehr1: TMenuItem;
    Basisgebuehr1: TMenuItem;
    Transakt1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    TrsaktReport: TMenuItem;
    Kontoreport1: TMenuItem;
    pnlZahlen: TPanel;
    lblBetrag: TLabel;
    Normal1: TMenuItem;
    Jugend1: TMenuItem;
    Vorzug1: TMenuItem;
    System1: TMenuItem;
    cbxCustomer: TComboBox;
    grpBox: TGroupBox;
    transSave: TMenuItem;
    Monitor1: TMenuItem;
    VtChart1: TVtChart;
    Reports1: TMenuItem;
    Vermoegen1: TMenuItem;
    Kosten1: TMenuItem;
    Zinsen1: TMenuItem;
    dlgSuchen: TFindDialog;
    mnuitSuchen: TMenuItem;
    Configur1: TMenuItem;
    ExportFile1: TMenuItem;
    ImportFile1: TMenuItem;
    charts: TMenuItem;
    nclipboard: TMenuItem;
    procedure btnShowKontoClick(Sender: TObject);
    procedure btnKreditLimitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnBuchenClick(Sender: TObject);
    procedure btnUmsatzClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure MonitorClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure saveReport1Click(Sender: TObject);
    procedure readFile1Click(Sender: TObject);
    procedure Kundendaten2Click(Sender: TObject);
    procedure Kontoarten1Click(Sender: TObject);
    procedure saveKontoBank1Click(Sender: TObject);
    procedure Depotgebuehr1Click(Sender: TObject);
    procedure Transakt1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure About1Click(Sender: TObject);
    procedure TrsaktReportClick(Sender: TObject);
    procedure Normal1Click(Sender: TObject);
    procedure saveBank1Click(Sender: TObject);
    procedure System1Click(Sender: TObject);
    procedure cbxCustomerDblClick(Sender: TObject);
    procedure transSaveClick(Sender: TObject);
    procedure Zinsen1Click(Sender: TObject);
    procedure mnuitSuchenClick(Sender: TObject);
    procedure dlgSuchenFind(Sender: TObject);
    procedure Monitor1Click(Sender: TObject);
    procedure Vermoegen1Click(Sender: TObject);
    procedure Configur1Click(Sender: TObject);
    procedure chartsClick(Sender: TObject);
    procedure nclipboardClick(Sender: TObject);
 private
    reportList: TStringList;
    obBars: TProgBars;
    obMemo: TBMonitor;
    procedure showCustList;
    procedure createZinsform;
    procedure proxyAction(action: byte; amount: string);
 public
    procedure showView(kontdata: TStringList);
    procedure showAllKonto;
    procedure showViewGraph(strdata: TStringList);
 end;

TProgBars = class(TObserver)
private
  FBarX: TProgressBar;
  FBarY: TProgressBar;
  FBarZ: TProgressBar;
public
  constructor createBars(aParent: TWinControl);
  destructor Destroy; override;
  procedure Update(dispCenter: TObservable); override;
  procedure reset; override;
end;

TBMonitor = class(TObserver)
private
  frmMon: TForm;
  memMon: TMemo;
public
  constructor create(aOwner: TComponent);
  destructor Destroy; override;
  procedure Update(dispCenter: TObservable); override;
  procedure reset; override;
end;

TOwnProgressBar = class(TProgressBar)
 public
   constructor Create(aOwner: TComponent); override;
 end;

//type Transakt = (limite, buchen, umsatz, infile, gebuehren);

var
  frmBank: TfrmBank;

implementation

{$R *.DFM}

 uses ulooktrans, chartView, zinsView;

// as always the same like the CorpIdentity of the firm
procedure ShowInfoBox(boxCaption: string; versionCaption: string);
                                    far; external 'Infobox.dll';

constructor TProgbars.CreateBars(aParent: TWinControl);
begin
  inherited Create;
  FBarX:= TOwnProgressBar.Create(NIL);
  FBarY:= TOwnProgressBar.Create(NIL);
  FBarZ:= TOwnProgressBar.Create(NIL);
  FBarX.Parent:= aParent;
  FBarY.Parent:= aParent;
  FBarZ.Parent:= aParent;
end;

destructor TProgbars.Destroy;
begin
  FBarX.Free;
  FBarY.Free;
  FBarZ.Free;
  inherited Destroy;
end;

procedure TProgbars.Update(dispCenter: TObservable);
var tmpAmount: integer;
begin
  tmpAmount:= round((dispCenter as TDispCenter).getAmount)
                       * 100 div GRAPH_SCALE;
  FBarX.Position:= FBarX.Position + tmpAmount;
  FBarY.Position:= FBarY.Position + tmpAmount;
  FBarZ.Position:= FBarZ.Position + tmpAmount;
end;

procedure TProgbars.Reset;
begin
  FBarX.Position:= 0;
  FBarY.Position:= 0;
  FBarZ.Position:= 0;
end;

constructor TOwnProgressBar.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  Min:= 0;
  Max:= 100;
  Step:= 1;
  width:= 18;
  orientation:= pbVertical;
  Align:= alLeft;
end;

constructor TBMonitor.create(aOwner: TComponent);
begin
  frmMon:= TForm.create(aOwner);
  memMon:= TMemo.create(frmMon);
  memMon.parent:=frmMon;
  memMon.setbounds(10,10,250,150);
  frmMon.caption:= frmTrans.strLit[40];
  frmMon.hide;
 end;

destructor TBMonitor.Destroy;
begin
   //cause of pending events
   frmMon.release;
   frmMon:= NIL;
   inherited Destroy;
end;

procedure TBMonitor.Update(dispCenter: TObservable);
begin
  with memMon.lines do begin
    add(intToStr(ctr.KundenNo));
    add(floaTtoStr((dispCenter as TDispCenter).getAmount));
    add(timeToStr(time)+' / '+ dateToStr(date));
  end;
 if frmTrans.boolMonitor then frmMon.show;
end;

procedure TBMonitor.reset;
begin
  memMon.clear;
end;

procedure TfrmBank.showAllKonto;
begin
  with frmBank do begin
    memBank.Clear;
    if assigned(ctr.kontoClass) then begin
      showView(ctr.kontoClass.getData);
      showView(ctr.stockKonto.getData);
      showView(ctr.kreditKonto.getData);
      showViewGraph(NIL);
    end;
  end;
end;

procedure TfrmBank.showView(kontdata: TStringList);
var i: integer;
begin
  with memBank do begin
    scrollBars:= ssVertical;
    for i:= 1 to kontdata.count -1 do
       lines.add(kontdata.strings[i]);
    lines.add(frmTrans.drawline('-'));
  end;
end;

procedure TfrmBank.showViewGraph(strdata: TStringList);
begin
 with VtChart1 do begin
   chartType:= VtChChartType2dPie;
   columnCount:= 3;
   rowCount:= 1;
   column:= 1;
   data:= floatToStr(ctr.kontoClass.kontostand);
   column:= 2;
   data:= floatToStr(ctr.stockKonto.kontostand);
   column:= 3;
   data:= floatToStr(ctr.kreditKonto.kontostand);
   ShowLegend:= True;
 end;
end;


procedure TFrmBank.createZinsform;
begin
  try
    frmIncome:= TfrmIncome.create(NIL);
    frmIncome.ShowModal;
  finally
    frmIncome.Release;
  end;
end;


procedure TfrmBank.btnOpenClick(Sender: TObject);
begin
  if cbxCustomer.items.count > 1 then begin
    ctr.KundenNo:= StrToInt(frmBank.cbxCustomer.Text);
    ctr.createFactory
  end else
    showCustList;
    btnShowKontoClick(Sender);
end;

procedure TfrmBank.showCustList;
begin
  with cbxCustomer do begin
    clear;
    items:= ctr.getCustList;
    text:= items[0];
  end;
end;

procedure TfrmBank.cbxCustomerDblClick(Sender: TObject);
begin
  showCustList;
end;

procedure TfrmBank.btnShowKontoClick(Sender: TObject);
begin
//list and chart
  memBank.clear;
  showAllKonto;
end;

// sends the events to bankControll
procedure TfrmBank.proxyAction(action: byte; amount: string);
begin
  if action = 7 then ctr.ctrAction(NIL, action, amount);
  case frmBank.rGrp.ItemIndex of
      0: ctr.ctrAction(ctr.kontoClass, action, amount);
      1: ctr.ctrAction(ctr.stockKonto, action, amount);
      2: ctr.ctrAction(ctr.kreditKonto, action, amount)
     else
     MessageDlg(frmTrans.strLit[6], mtWarning,[mbok],0);
  end;
end;


procedure TfrmBank.btnKreditLimitClick(Sender: TObject);
begin
//action 1 is kreditlimite
  proxyAction(1, edtBetrag.text);
  showAllKonto;
end;

procedure TfrmBank.btnBuchenClick(Sender: TObject);
begin
//action 2 is buchen
  proxyAction(2, edtBetrag.text);
  showAllKonto;
end;

procedure TfrmBank.btnUmsatzClick(Sender: TObject);
begin
//action 3 is umsatz-statistik
  proxyAction(3, '');
  memBank.Clear;
  showView(ctr.tempList);
end;

procedure TfrmBank.btnSaveClick(Sender: TObject);
begin
  proxyAction(4, '');  //action 4 is speichern in file
end;

procedure TfrmBank.Depotgebuehr1Click(Sender: TObject);
begin
// action 5 is gebuehren
  if rGrp.ItemIndex = 1 then begin
    proxyAction(5, edtBetrag.text);
    showAllKonto
  end else
    MessageDlg(frmTrans.strLit[12], mtWarning,[mbok],0);
end;

procedure TfrmBank.Normal1Click(Sender: TObject);
begin
//action 5.x kreditgebuehren
  if rGrp.ItemIndex = 2 then begin
    if TMenuItem(Sender).name = 'Normal1' then
     proxyAction(51, edtBetrag.text);
    if TMenuItem(Sender).name = 'Vorzug1' then
     proxyAction(52, edtBetrag.text);
    if TMenuItem(Sender).name = 'Jugend1' then
     proxyAction(53, edtBetrag.text);
   showAllKonto;
  end else
   MessageDlg(frmTrans.strLit[11], mtWarning,[mbok],0);
end;

procedure TfrmBank.saveKontoBank1Click(Sender: TObject);
begin
//action 6 is speichern konto in dbank
  proxyAction(6, '');
end;

procedure TfrmBank.TrsaktReportClick(Sender: TObject);
begin
//action 8 is trsaktHistory
  proxyAction(8, '');
  memBank.clear;
  showView(ctr.tempList);
end;


procedure TfrmBank.saveBank1Click(Sender: TObject);
begin
//action is speichern alle konto in dbank
//no question about kontoart
  ctr.saveToBase;
end;

procedure TFrmBank.saveReport1Click(Sender: TObject);
var  i: integer;
begin
  with memBank do begin
    reportList.clear;
    for i:= 0 to lines.count -1 do
      reportList.add(lines[i]);
  end;
 //Data of Memo
 ctr.toFile(reportList);
end;

procedure TfrmBank.readFile1Click(Sender: TObject);
begin
  reportList.Clear;
  memBank.lines:= ctr.fromFile(reportList);
end;

procedure TfrmBank.System1Click(Sender: TObject);
begin
  reportList.clear;
  memBank.lines:= ctr.ctrStream(reportList);
end;

//*******************************************************
procedure TfrmBank.FormCreate(Sender: TObject);
begin
  frmTrans:= TfrmTrans.Create(self);
  //constructor
  ctr:= TCtrClass.CtrCreate;
  frmChart:=TfrmChart.create(self);
  obBars:= TProgBars.createBars(grpBox);
  obMemo:= TBMonitor.create(NIL);
  //register observer
  with ctr.dispCtr do begin
    add(obBars);
    add(obMemo);
  end;
  frmTrans.specialButtons(frmBank);
  reportList:= TStringList.create;
  keyPreview:= true;
end;


procedure TfrmBank.FormDestroy(Sender: TObject);
begin
 //list for file saving
  reportList.free;
 //deregister
  with ctr.dispCtr do begin
    remove(obBars);
    remove(obMemo);
  end;
  obBars.Free;
  obMemo.Free;
  ctr.Free;
  frmChart.release;
  frmTrans.Release;
end;

procedure TfrmBank.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

// simuliert eine transaktionsberwachung als beispiel einer
// assoziation zur laufzeit
procedure TfrmBank.MonitorClick(Sender: TObject);
begin
  transMonitor.createTrans(NIL);
end;

procedure TfrmBank.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then close;
end;

procedure TfrmBank.Zinsen1Click(Sender: TObject);
begin
  createZinsform;
end;

procedure TfrmBank.Configur1Click(Sender: TObject);
begin
  frmTrans.ShowModal;
end;

procedure TfrmBank.Vermoegen1Click(Sender: TObject);
begin
 membank.clear;
  with membank.lines do begin
    add(frmTrans.strLit[17]);
    add(floatToStr(ctr.getVermoegen));
  end;
end;

procedure TfrmBank.Kundendaten2Click(Sender: TObject);
begin
  ctr.ctrMutationen(1);
end;

procedure TfrmBank.Kontoarten1Click(Sender: TObject);
begin
  ctr.ctrMutationen(2);
end;

procedure TfrmBank.Transakt1Click(Sender: TObject);
begin
  ctr.ctrMutationen(3);
end;

procedure TfrmBank.transSaveClick(Sender: TObject);
begin
  transSave.checked := not transSave.checked;
  if transSave.checked then frmTrans.boolLogSave:= true
   else frmTrans.boolLogSave:= false;
end;

procedure TfrmBank.Monitor1Click(Sender: TObject);
begin
  monitor1.checked := not monitor1.checked;
  if monitor1.checked then frmTrans.boolMonitor:= true
   else frmTrans.boolMonitor:= false;
end;

procedure TfrmBank.About1Click(Sender: TObject);
begin
  showInfoBox(frmTrans.strLit[15],frmTrans.strLit[16]);
end;

procedure TfrmBank.mnuitSuchenClick(Sender: TObject);
begin
  dlgSuchen.execute;
end;

procedure TfrmBank.dlgSuchenFind(Sender: TObject);
begin
  frmTrans.txtsearch(frmBank, memBank, dlgSuchen, memBank.text);
end;

procedure TfrmBank.chartsClick(Sender: TObject);
begin
  frmChart.Show;
end;

procedure TfrmBank.nclipboardClick(Sender: TObject);
begin
  ctr.copyToClipboard(memBank);
end;

end.

