{-Modulename and path: ulooktrans
//
//D:\franktech\UMLbook\UMLbook2\designPattern\dpatterns\patterns7.mpb
//Category    Service
//LoC=719
//Developer kleiner kommunikation
//Last Modification on 14.06.03 22:06:47:
//P: patterns: template, lock, chain, a sort of monitor
  a utility unit for global routines and consts
  8.3.03 config optimal period
  12.5.04 adaption to Broker2
  a transaction monitor/ translation preparing
  10.10.04 pascal analyzer code reduction
//==========================================================================}
unit ulooktrans;

interface

uses
  Controls, Forms, dialogs,
      StdCtrls, Buttons, Classes, sysUtils, ExtCtrls;

type
  TLiterale = array[0..90] of string;
  TSMS_Box = class;
  TMessageClass = class;
  TShortStr = string[55];
  TSMSText = string[156];

  TfrmTrans = class (TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    cbcrypt: TCheckBox;
    cboptimise: TCheckBox;
    chkBox_Stat: TCheckBox;
    chkfixchart: TCheckBox;
    edtCycle: TEdit;
    edtDay: TEdit;
    edtDBPath: TEdit;
    edtDist: TEdit;
    edtFilelements: TEdit;
    edtFilename: TEdit;
    edtfrom: TEdit;
    edtGraphskala: TEdit;
    edtRandom: TEdit;
    edtPassword: TEdit;
    edtTo: TEdit;
    edtWSPath: TEdit;
    GroupBox1: TGroupBox;
    grpBoxRate: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    lblDB: TLabel;
    lblDirname: TLabel;
    lblFilename: TLabel;
    lblGraph: TLabel;
    lblJugend: TLabel;
    lblNorm: TLabel;
    lblopt: TLabel;
    lblPasswort: TLabel;
    lblVorzug: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edtNormal: TEdit;
    edtVorzug: TEdit;
    edtJugend: TEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure edtFilelementsExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FNextPers: TSMS_Box;
    messageStatus: Boolean;
    IB_DIR: string[255];
    procedure fillConfig;
    procedure fillLiterals;
    //function stringToComponent(value: string): TComponent;
  public
    password: string[255];
    boolLogSave: Boolean;
    boolMonitor: Boolean;
    strLit: TLiterale;
    function checkOBJ(aObject: TObject): Boolean;
    //function createControl(aControl: TControlClass; const aName: string;
    //        aOwner: TControl; aParent: TWinControl; x,y,w,i: Integer): TControl;
    function drawLine(pattern: char): string;
    function executeTemplate: TStrings;
    function GetFileList(const Path: string): TStringList;
    function GetWinner: TStringList;
    procedure sortPerflist(var mylist: Tstringlist);
    procedure specialButtons(aForm: TForm);
    procedure txtSearch(aForm:TControl; aContainer:TControl;
            aDialog:TFindDialog; content: string);
  end;


  TTransMonitor = class (TComponent)
  private
    frmMon: TForm;
    memMon: TMemo;
    STLock: Integer;
  protected
    function locked: Boolean;
    procedure setLocking(signal: boolean);
    procedure showTrans(Sender: TObject; var Done: Boolean);
  public
    constructor create(aOwner: TComponent); override;
    destructor Destroy; override;
    procedure addTransactions(amount: string);
    function createTrans(aOwner: TComponent): Boolean;
    procedure Lock;
    procedure Unlock;
  end;

  TMessageClass = class (TObject)
  private
    ccount: Byte;
    FAdress: TShortStr;
    FShortText: TSMSText;
  public
    constructor create(shorttxt, myAdress: TShortStr);
    function getAdress: TShortStr;
    function getShortText: TSMSText;
  end;

  TSMS_Box = class (TObject)
  private
    FGroup: TShortStr;
    FNext: TSMS_Box;
    FUsername: TShortStr;
    function cleanup(sText: Shortstring): ShortString;
  public
    constructor create(uname, group: TShortStr);
    function getGroup: TshortStr;
    function getName: TShortStr;
    procedure processSMS(sms: TMessageClass; vtrans: TFrmTrans);
    procedure sendSMS;
    procedure setNext(next: TSMS_Box);
  end;

const
  REG_RATE: double = 0.25;
  PREFERED_RATE: double = 0.17;
  TRIAL_RATE: double = 0.04;
  GRAPH_SCALE: integer = 20000;
  SPAR_KTO = 4;
  STOCK_KTO = 5;
  KRED_KTO = 6;
//HYPO_KTO = 7;
//POST_KTO = 8;
  TRADE_ROBOT_VERSION = 1.2;
//DB_OWNER ='max';
  CLIENT_BASE = 100;
//DB_ALIAS = 'IBLOCAL';
  DB_ALIAS = 'UML_BANK';
  DB_NAME = 'umlbank';
  DISTMIN: byte = 15;
  DAYMIN: byte = 10;
  MA_CYCLE: byte = 33;
  MA_LONG: byte = 155;
  O_FROM: byte = 29;
  O_TO: byte = 45;
  BUYSYM: byte = 1;
  SELLSYM: byte = 2;
  CHDAT: integer = 900;
  RANDHIGH: byte = 9;
  RANDLOW: byte = 9;
  ST_SHORT = 40 ;
  ST_DELIMCONCATSTR = '; ' ;
  uFILENAME: string[255] ='bankfile.txt';
  FILENAMEchart: string[255] ='chart7up.txt';
  TESTFILE: string[255] ='test1.txt';
//STREAMFILE: string[255] ='chartfile.txt';
  STREAMFILE: string[255] ='chaosmax.pas';
//COPYFILE: string[255] ='chartfilecopy_stream.txt';
  CRYPTFILE: string[255] ='mycrypt.txt';
  SYSFILE: string ='\ulooktrans.pas';
  REGKEY: string[255] = 'HKEY_CURRENT_USER';
//IB_DIR: string='Database=milo2:D:\franktech\umlkap3\delphi_interbase\ib_bank\umlbank.gdb';
WSURL1: string='http://milo2/scripts/vclscannerserver.exe/soap/IVCLScanner';
//WSURL2: string='http://milo/cgi-bin/vclscannerserver.exe/soap/IVCLScanner';
SMSURL: string='http://sal006.salNetwork.com:83/lucin/SMSmessaging/process.xml';

var
  frmTrans: TfrmTrans;
  transMonitor: TTransMonitor;


implementation

{$R *.dfm}

 uses comObj, uFilexport, windows;


{
********************************** TfrmTrans ***********************************
}

procedure TfrmTrans.fillConfig;
begin
  edtGraphskala.text:= intToStr(GRAPH_SCALE);
  edtWSPath.Text:=WSURL1;
  edtDBPath.text:=IB_DIR;
  edtDay.text:=intToStr(DAYMIN);
  edtDist.text:=intToStr(DISTMIN);
  edtCycle.text:=inttoStr(MA_CYCLE);
  edtFilename.text:= FILENAMEChart;
  edtFilelements.text:= inttoStr(CHDAT);
  edtRandom.text:= inttoStr(RANDHIGH);
  edtFrom.text:= inttoStr(O_FROM);
  edtTo.text:= inttoStr(O_TO);
  edtPassword.text:= password;
  edtNormal.text:= FloattoStr(REG_RATE);
  edtVorzug.Text:= FloattoStr(PREFERED_RATE);
  edtJugend.text:= floattoStr(TRIAL_RATE);

end;

procedure TfrmTrans.fillLiterals;
begin
   strLit[2]:='Kreditlimite aendern';
   strLit[3]:='No Password choosen or wrong';
   strLit[4]:='Object not found';
   strLit[5]:='noch kein Tages-Umsatz im Konto getaetigt';
   strLit[6]:='Zuerst ein Konto auswaehlen';
   strLit[7]:='Bitte ein Konto-Nr. aktivieren';
   strLit[8]:='KontoNr: ';
   strLit[9]:='Transaktion abgeschlossen';
   strLit[10]:='Kreditimite ueberzogen';
   strLit[11]:='Jahresgebuehr nur bei Kreditkonto';
   strLit[12]:='Depotgebuehr nur bei Stockkonto';
   strLit[13]:='ein Kontotyp fehlt';
   strLit[14]:='Transaction Monitor';
   strLit[15]:='Patterns konkret ';
   strLit[16]:='Vol. 1.3.b';
   strLit[17]:='Das Vermoegen aller Konten ist: ';
   strLit[18]:='No open file allowed';
   strLit[19]:='Datenbankalias nicht gefunden';
   strLit[20]:='Transaktion gespeichert?';
   strLit[40]:='Observer Monitor';
   strLit[41]:='Kontonummer nicht gefunden';
   strLit[42]:='Kundennummer nicht gefunden';
   strLit[43]:='SYSTEM_FILES der Datenbank';
   strLit[44]:='DUnit Testing';
   strLit[45]:='No File was selected';
   strLit[46]:='muss String sein im Betrag';
   strLit[47]:='first Exception from optMovingAvg';
   strLit[48]:='c:\autoexec.bat'; //depends on OS
   strLit[49]:='c:\config.sys';
   strLit[50]:='c:\windows\win.ini';
   strLit[51]:='c:\windows\system.ini';
   strLit[52]:='c:\windows\hosts';
   strLit[53]:='c:\windows\Services';
   strLit[59]:='max@kleiner.com';
   strLit[60]:='***this is a multiple transactionline***';
   strLit[21]:='&Close_Tree';
   strLit[22]:='&Open_Tree';
   strLit[23]:='SMS via controller sended ';
   strLit[24]:='see result in TotalList behind ';
   strLit[25]:='Could not fill Performance List';
   strLit[26]:=' = Chart Days ';
   strLit[27]:='status...Timer is halted';
   strLit[28]:='status...Timer is going';
   strLit[29]:='Could not fill All_OMA List';
   strLit[30]:='Chart file load error ';
   strLit[31]:='SMS send successfully';
   strLit[32]:='SMS sending failed';
   strLit[33]:='RWalk Chart Simulation';
   strLit[34]:='Delta Opt.MovingAverage';
   strLit[35]:='Opt. MovingAverage Error';
   strLit[70]:='NUMB';
   strLit[71]:='..Broker is already running...';
   strLit[72]:='TRadeRobot (*.txt)| *.txt';
   strLit[73]:='maTRIx Trade Robot';
   strLit[74]:='Chart: ';
end;


procedure TfrmTrans.BitBtn1Click(Sender: TObject);
begin
  DAYMIN:=strToInt(edtDay.text);
  DISTMIN:=strtoInt(edtDist.text);
  MA_CYCLE:=strtoInt(edtCycle.text);
  FILENAMEChart:=edtFilename.text;
  GRAPH_SCALE:=strToInt(edtGraphskala.text);
  WSURL1:= edtWSPath.Text;
  CHDAT:= strtoint(edtFilelements.text);
  IB_DIR:= edtDBPath.text;
  RANDHIGH:=strtoint(edtRandom.text);
  O_FROM:=strtoint(edtFrom.text);
  O_TO:=strtoint(edtTo.text);
  REG_RATE:= strToFloat(edtNormal.text);
  PREFERED_RATE:= strtoFloat(edtVorzug.text);
  TRIAL_RATE:= strtoFloat(edtJugend.text);
  password:= edtPassword.text;

end;

procedure TfrmTrans.BitBtn2Click(Sender: TObject);
begin
  close;
end;

function TfrmTrans.checkOBJ(aObject: TObject): Boolean;
var
  S: string;
  i: Integer;
begin
  result:= false;
  if aObject = NIL then
    exit;
  try
    S:= ansiUppercase(aObject.classname);
    if S= '' then exit;
    for i:= 1 to length(S) do
    if not (S[i]in['0'..'9','A'..'Z','_']) then exit;
    aObject.classType;
    if aObject.InstanceSize <1 then exit;
    aObject.ClassnameIs('TObject');
    result:=aObject.ClassNameIs(aObject.Classname);
  except
    exit;
  end;
end;

{function TfrmTrans.createControl(aControl: TControlClass; const aName: string;
        aOwner: TControl; aParent: TWinControl; x,y,w,i: Integer): TControl;
begin
  result:= aControl.create(aOwner);
  with result do begin
    parent:= aParent;
    name:= aName;
    setBounds(x,y,w,i);
    visible:= true;
  end;
end;}

function TfrmTrans.drawLine(pattern: char): string;
var
  i: Byte;
  myline: array[0..50] of char;
begin
  for i:= 0 to 50 do myline[i]:= pattern;
  result:= myline;
end;

procedure TfrmTrans.edtFilelementsExit(Sender: TObject);
begin
  if strtoint(edtFilelements.text) > 1600 then
                       edtFilelements.text:= '1600';
end;

// TStream.CopyFrom() method uses WriteBuffer() and ReadBuffer() template methods
// that in turn call Read() and Write(), which are the abstract methods that must
// be implemented by derived classes: TCustomMemoryStream and TStringStream

function TfrmTrans.executeTemplate: TStrings;
var
  M: TMemoryStream;
  S: TStringStream;
begin
  M:= TMemoryStream.Create;
  S:= TStringStream.Create('');
  Result := TStringList.Create;
  try
    M.LoadFromFile(ExtractFilePath(Application.ExeName)+ TESTFILE);
    M.Seek(0,0);
    S.CopyFrom(M, M.Size);
    S.Seek(0,0);
    with result do begin
      Clear;
      Add(S.ReadString(S.Size));
    end;
  finally
    M.Free;
    S.Free;
  end;
end;

procedure TfrmTrans.FormActivate(Sender: TObject);
begin
  fillConfig;
end;

procedure TfrmTrans.FormCreate(Sender: TObject);
begin
  password:= 'max';
  IB_DIR:= DB_ALIAS;
  boolLogSave:= true;
  boolMonitor:= true;
  messageStatus:= false;
  fillLiterals;
  fillConfig;
  FNextPers:= NIL;
end;


function TfrmTrans.GetFileList(const Path: string): TStringList;
var
  i: Integer;
  SearchRec: TSearchRec;
begin
  Result:= TStringList.Create;
  try
    i:= FindFirst(Path, 0, SearchRec);
    while i= 0 do begin
      Result.Add(SearchRec.Name);
      i:= FindNext(SearchRec);
    end;
  except
    Result.Free;
    raise;
  end;
end;

function TfrmTrans.GetWinner: TStringList;
var
  i, bet: Integer;
  betS: string[4];
begin
   Result:= TStringList.Create;
   try
     randomize;
     for i:= 1 to 15 do begin
      bet:=random((1000)+100);
      if bet < 1000 then begin
        bet:= bet+1000;
        betS:= intTostr(bet);
        betS[1]:= '0';
      end else
       betS:=intToStr(bet);
      result.add(betS+ strLit[44]);
     end;
     result.Sort;
  except
     Result.Free;
     raise;
   end;
end;


procedure TfrmTrans.sortPerflist(var mylist: Tstringlist);
var
  i: Integer;
begin
  try
    with mylist do begin
       for i:= 0 to count -1 do begin
         if length(Strings[i]) < 6 then
           strings[i]:= format('%s%s%s',['0','0',strings[i]]);
         if length(Strings[i]) = 6 then
           strings[i]:= format('%s%s',['0',strings[i]]);
       end;
     Sort;
    end;
  except
    raise;
  end;
end;

procedure TfrmTrans.specialButtons(aForm: TForm);
var
  cTemp: TComponent;
  i: Integer;
  rgn: hRgn;
begin
  for i := aForm.ComponentCount - 1 downto 0 do begin
    if (aForm.components[i] is TButton) then begin
      cTemp := aForm.Components[i];
      with TButton(cTemp) do begin
       rgn:= createRoundRectRgn(0,0,width,height,20,20);
       setWindowRgn(handle, rgn, true);
      end;
    end;
  end;
end;

{function TfrmTrans.stringToComponent(value: string): TComponent;
var
  StrStream: TStringStream;
  BinStream: TMemoryStream;
begin
  begin
    StrStream:= TStringStream.Create(Value);
    try
      BinStream:= TMemoryStream.Create;
      try
        ObjectTextToBinary(StrStream, BinStream);
        BinStream.Seek(0, soFromBeginning);
        Result:= BinStream.ReadComponent(NIL);
      finally
        BinStream.Free;
      end;
    finally
      StrStream.Free;
    end;
  end
end;}

procedure TfrmTrans.txtSearch(aForm:TControl; aContainer:TControl;
        aDialog:TFindDialog; content: string);
var
  strSuchText, strQuelle: string;
  carLaenge, carPosition: Cardinal;
begin
  strSuchText := aDialog.FindText;
  carLaenge   := Length(strSuchText);
  strQuelle   := content;
  if frMatchcase in aDialog.options then
  carPosition:= Pos(uppercase(strSuchText),uppercase(strQuelle))
  else carPosition:= Pos(strSuchText,strQuelle);
  if carPosition > 0 then begin
    aForm.BringToFront;
    if assigned(aContainer) then begin
      TForm(aForm).ActiveControl:= TWinControl(aContainer);
      TMemo(aContainer).SelStart:= carPosition -1;
      TMemo(aContainer).SelLength:= carLaenge;
    end else raise Exception.Create('text memo is missing');
  end else begin
    MessageDlg(
      '"'+ strSuchText + '" pattern not found',
      mtInformation, [mbOK], 0);
  end;
end;


//------------------------------------------------------------------------
//Template pattern sample
//  For implementation details see the VCL
//  TStream, TCustomMemoryStream, and TStringStream in classes.pas
//Note:
//  The sample provided is rather contrived, since we can accomplish
//  the solution by using Memo.Lines.LoadFromFile(), but the point is
//  to show the template method pattern in action.
//------------------------------------------------------------------------

{
******************************** TTransMonitor *********************************
}
constructor TTransMonitor.create(aOwner: TComponent);
begin
  // check also with onEvent
  application.OnIdle:= showTrans;
  frmMon:= TForm.create(aOwner);
  memMon:= TMemo.create(frmMon);
  memMon.parent:=frmMon;
  memMon.setbounds(10,10,250,150);
  frmMon.caption:=frmTrans.strLit[14];
  frmMon.show;
end;

destructor TTransMonitor.Destroy;
begin
  if assigned(frmMon) then begin
  // cause of pending events
    frmMon.release;
    frmMon:= NIL;
  end;
  transmonitor:=NIL;
  inherited Destroy
end;

procedure TTransMonitor.addTransactions(amount: string);
begin
//unlock zum anfang
  STLock:=0;
  lock;
  try
    with memMon.lines do begin
      add('Interrupt: ' + amount);
      add(timeTostr(time)+' / '+ dateToStr(date));
      add(frmTrans.drawline('*'));
    end;
 //garantierte freigabe (deadlock verhindern)
  finally
    unlock
  end;
end;

function TTransMonitor.createTrans(aOwner: TComponent): Boolean;
begin
  frmTrans.messageStatus:= not frmTrans.messageStatus;
  if frmTrans.messageStatus then begin
    transMonitor:= TTransMonitor.create(aOwner);
    result:= true
   //test with no NIL
  end else begin
    try
      application.onIdle:= NIL;
      if assigned(frmMon) then begin
       //cause of pending events
       frmMon.release;
       frmMon:= NIL;
      end;
    finally
      transmonitor.free;
      result:= false;
    end;
  end;
end;

procedure TTransMonitor.Lock;
begin
  //locked > 0 , unlock =0
  inc(STLock);
  if STLock = 1 then setLocking(true);
end;

function TTransMonitor.locked: Boolean;
begin
  result:=(STLock <> 0);
end;

procedure TTransMonitor.setLocking(signal: boolean);
begin
  if signal then application.onIdle:= NIL else
    application.onIdle:= showTrans;
end;

procedure TTransMonitor.showTrans(Sender: TObject; var Done: Boolean);
var
  myObj: string;
begin
  //myObj:= TObject(Sender).classname;
  //const N = 2002;
  if TTransMonitor(Sender).ClassParent <> NIL then
  myObj:= TTransMonitor(Sender).classname;
  //simulation des datenflusses
  memMon.lines.add(IntToStr(random(1000000))+':  '
            +'  '+timeToStr(time)+'  '+myObj);
  done:= true
end;

procedure TTransMonitor.Unlock;
begin
  dec(STLock);
  if STLock = 0 then setLocking(false);
end;


{
******************************** TMessageClass *********************************
}
constructor TMessageClass.create(shorttxt, myAdress: TShortStr);
begin
  FShortText:= shorttxt;
  FAdress:= myAdress;
  ccount:= 0;
end;

function TMessageClass.getAdress: TShortStr;
begin
  result:= FAdress
end;

function TMessageClass.getShortText: TSMSText;
begin
  result:= FShortText
end;


{
*********************************** TSMS_Box ***********************************
}
constructor TSMS_Box.create(uname, group: TShortStr);
begin
  FUserName:= uname;
  FGroup:= group;
end;

function TSMS_Box.cleanup(sText: Shortstring): ShortString;
begin
  while (pos(#13, sText)> 0) do
    sText[pos(#13, sText)]:=' ';
  while (pos(#10, sText)> 0) do
    delete(sText, pos(#10, sText), 1);
  result:= sText;
end;

function TSMS_Box.getGroup: TshortStr;
begin
  result:= FGroup
end;

function TSMS_Box.getName: TShortStr;
begin
  result:= FUsername
end;

procedure TSMS_Box.processSMS(sms: TMessageClass; vtrans: TFrmTrans);
begin
end;

procedure TSMS_Box.sendSMS;
var
  soapClient: OLEVariant;
  res: Boolean;
begin
  soapClient:= createOleObject('MSSOAP.soapClient');
  soapClient.MSSoapInit(SMSURL);
  res:=soapClient.sendMessage('4471277',cleanup('testB is on the air'),
                                   frmTrans.strLit[59],'password');
  if res then
    showmessage(frmTrans.strLit[31])
  else
    showmessage(frmTrans.strLit[32]);
end;

procedure TSMS_Box.setNext(next: TSMS_Box);
begin
  FNext:= next
end;

end.




