SET SQL DIALECT 1;

/* V 1.2 2005 to set a new Database, change the Name and User */
/*
    THIS FILE IS FOR USE WITH THE TUTORIAL "UML2 Praxisbuch",
    IT IS NOT MEANT TO BE USED WITHOUT REFERRING TO THE MANUAL.
    
*   You must change the parameters below to match your
*   server name, database name , username, and password.
*   This file defines tables, triggers, views etc. for the BROKER database.
*   To Insert data at the end of script, DB has to be connected!
*/

CREATE DATABASE "D:\kleiner2005\Delphi_InterBase\ib_bank\UMLBANK12.GDB"
User "SYSDBA" Password "masterkey"
PAGE_SIZE 1024;
/*DEFAULT CHARACTER SET*/

/*CONNECT "D:\kleiner2005\Delphi_InterBase\ib_bank\UMLBANK11.GDB"
User "SYSDBA" Password "masterkey";*/

/* Domain definitions */
CREATE DOMAIN ADDRESSLINE AS VARCHAR(30);
CREATE DOMAIN AMOUNT AS NUMERIC(15, 2)
	 DEFAULT 0
	 CHECK (VALUE > 0);
CREATE DOMAIN CUSTNO AS INTEGER
	 CHECK (VALUE > 1000);
CREATE DOMAIN FIRSTNAME AS VARCHAR(15);
CREATE DOMAIN LASTNAME AS VARCHAR(20);
CREATE DOMAIN PHONENUMBER AS VARCHAR(20);

/* Table: ACCOUNT, Owner: MAX */

CREATE TABLE ACCOUNT 
(
  ACC_NO	INTEGER NOT NULL,
  CUST_NO	INTEGER,
  ACC_TYPE	SMALLINT,
  AMOUNT	NUMERIC(15, 2),
  LIMIT	AMOUNT,
  FEE	AMOUNT,
  MUTDATE	TIMESTAMP,
CONSTRAINT P_ACCOUNT PRIMARY KEY (ACC_NO)
);

/* Table: ACCTYPE, Owner: MAX */

CREATE TABLE ACCTYPE 
(
  ACC_ID	SMALLINT NOT NULL,
  DESCRIPT	VARCHAR(50),
  MUTDATE	TIMESTAMP,
CONSTRAINT ACCTYPEPRIMARY PRIMARY KEY (ACC_ID)
);

/* Table: CUSTOMER, Owner: MAX */

CREATE TABLE CUSTOMER 
(
  CUST_NO	CUSTNO NOT NULL,
  CUSTOMER	VARCHAR(25) NOT NULL,
  CONTACT_FIRST	FIRSTNAME,
  CONTACT_LAST	LASTNAME,
  PHONE_NO	PHONENUMBER,
  ADDRESS_LINE1	ADDRESSLINE,
  ADDRESS_LINE2	ADDRESSLINE,
  CITY	VARCHAR(25),
  COUNTRY	VARCHAR(15),
  POSTAL_CODE	VARCHAR(12),
  ON_HOLD	CHAR(1) DEFAULT NULL,
  MUTDATE	TIMESTAMP,
 PRIMARY KEY (CUST_NO)
);

/* Table: KINGS, Owner: SYSDBA */

CREATE TABLE KINGS 
(
  KINGS_ID	INTEGER NOT NULL,
  EMAIL	VARCHAR(40),
  FIRSTNAME	VARCHAR(30),
  LASTNAME	VARCHAR(30),
  MUTDATE	VARCHAR(18)
);

/* Table: TRANS, Owner: MAX */

CREATE TABLE TRANS 
(
  TRANS_ID	INTEGER NOT NULL,
  ACC_NO	INTEGER NOT NULL,
  TRANSAMOUNT	INTEGER,
  OPENDATE	TIMESTAMP,
  OPENPERSON	LASTNAME,
  MUTDATE	TIMESTAMP,
  MUTPERSON	LASTNAME,
CONSTRAINT TRANSPRIMARY PRIMARY KEY (TRANS_ID)
);

/* Table: TRANS1, Owner: MAX */

CREATE TABLE TRANS1 
(
  TRANS_ID	INTEGER NOT NULL,
  ACC_NO	INTEGER NOT NULL,
  TRANSAMOUNT	NUMERIC(15, 2),
  OPENDATE	TIMESTAMP,
  OPENPERSON	LASTNAME,
  MUTDATE	TIMESTAMP,
  MUTPERSON	LASTNAME,
CONSTRAINT TRANS1PRIMARY PRIMARY KEY (TRANS_ID)
);

/*  Index definitions for all user tables */

CREATE INDEX CUSTNAMEX ON CUSTOMER(CUSTOMER);

CREATE GENERATOR ACCOUNT_GEN;
CREATE GENERATOR ACCTYPE_GEN;
CREATE GENERATOR CUSTOMER_GEN;
CREATE GENERATOR KINGS_GEN;
CREATE GENERATOR TRANS_GEN;



/* View: ALLACCOUNTS, Owner: MAX */

CREATE VIEW ALLACCOUNTS (
  ACC_NO, 
  DESCRIPT, 
  AMOUNT, 
  LIMIT, 
  FEE
) AS
 SELECT

 acc_no, descript, amount, limit, fee
    FROM account, acctype
  WHERE cust_NO = 1001
  and account.acc_type = acctype.acc_id
;

/* View: ALLACCOUNTS1, Owner: MAX */

CREATE VIEW ALLACCOUNTS1 (
  CUSTOMER, 
  ACC_NO, 
  DESCRIPT, 
  AMOUNT, 
  LIMIT, 
  FEE
) AS
 SELECT

 customer, acc_no, descript, amount, limit, fee
    FROM account, acctype, customer
  WHERE account.cust_no = customer.cust_no 
  and account.acc_type = acctype.acc_id
;
ALTER TABLE CUSTOMER ADD
CHECK (on_hold IS NULL OR on_hold = '*');

COMMIT WORK;
SET AUTODDL OFF;
SET TERM ^ ;

/* Stored procedures */

CREATE PROCEDURE GETACCOUNTS 
(
  CUST_NO INTEGER
)
RETURNS
(
  ACC_NO INTEGER,
  DESCRIPT VARCHAR(50),
  AMOUNT NUMERIC(15, 2),
  LIMIT NUMERIC(15, 2),
  FEE NUMERIC(15, 2)
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE GETCUST_NO 
(
  ACC_NO INTEGER
)
RETURNS
(
  CUST_NO INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_NEXT_ACCTYPE_ID 
RETURNS
(
  NEXT_ACCTYPE_ID INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_NEXT_ACC_ID 
RETURNS
(
  NEXT_ACC_ID INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_NEXT_CUST_ID 
RETURNS
(
  NEXT_CUST_ID INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_NEXT_KINGS_ID 
RETURNS
(
  NEXT_KINGS_ID INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_NEXT_TRANS_ID 
RETURNS
(
  NEXT_TRANS_ID INTEGER
)
AS
BEGIN EXIT; END ^

CREATE PROCEDURE SP_SETTRANS 
(
  AMOUNT NUMERIC(15, 2),
  ACCNO INTEGER,
  TRANSDATE TIMESTAMP
)
AS
BEGIN EXIT; END ^


ALTER PROCEDURE GETACCOUNTS 
(
  CUST_NO INTEGER
)
RETURNS
(
  ACC_NO INTEGER,
  DESCRIPT VARCHAR(50),
  AMOUNT NUMERIC(15, 2),
  LIMIT NUMERIC(15, 2),
  FEE NUMERIC(15, 2)
)
AS
  DECLARE VARIABLE cnt INTEGER;
BEGIN

 SELECT count(acc_no)    
  FROM account, acctype
  WHERE cust_NO = :cust_no
  and account.acc_type = acctype.acc_id
    INTO :cnt;
 
  if (cnt < 1) then exit;
FOR 
 SELECT acc_no, descript, amount, limit, fee
    FROM account, acctype
  WHERE cust_NO = :cust_no
  and account.acc_type = acctype.acc_id
  order by acc_no
    INTO :acc_no, :descript, :amount, :limit, :fee
  do begin
     suspend;
    cnt = cnt -1;
    if (cnt < 1) then exit;
  end
  /*suspend;*/
END
 ^


ALTER PROCEDURE GETCUST_NO 
(
  ACC_NO INTEGER
)
RETURNS
(
  CUST_NO INTEGER
)
AS
BEGIN
  FOR SELECT cust_no
  FROM account
  WHERE Acc_NO = :Acc_NO
  INTO :cust_no
  DO
    SUSPEND;
END
 ^


ALTER PROCEDURE SP_NEXT_ACCTYPE_ID 
RETURNS
(
  NEXT_ACCTYPE_ID INTEGER
)
AS
   begin 
 next_acctype_id = gen_id(acctype_gen,1);
end
 ^


ALTER PROCEDURE SP_NEXT_ACC_ID 
RETURNS
(
  NEXT_ACC_ID INTEGER
)
AS
  begin 
 next_acc_id = gen_id(account_gen,1);
end
 ^


ALTER PROCEDURE SP_NEXT_CUST_ID 
RETURNS
(
  NEXT_CUST_ID INTEGER
)
AS
  begin 
 next_cust_id = gen_id(customer_gen,1);
end
 ^


ALTER PROCEDURE SP_NEXT_KINGS_ID 
RETURNS
(
  NEXT_KINGS_ID INTEGER
)
AS
   begin 
 next_kings_id = gen_id(kings_gen,1);
END
 ^


ALTER PROCEDURE SP_NEXT_TRANS_ID 
RETURNS
(
  NEXT_TRANS_ID INTEGER
)
AS
   begin 
 next_trans_id = gen_id(trans_gen,1);
end
 ^


ALTER PROCEDURE SP_SETTRANS 
(
  AMOUNT NUMERIC(15, 2),
  ACCNO INTEGER,
  TRANSDATE TIMESTAMP
)
AS
BEGIN
  INSERT INTO TRANS1(TRANSAMOUNT, ACC_NO, OPENDATE)
  VALUES (:amount, :accNo, :transdate);     

 
    SUSPEND;

 
END
 ^

SET TERM ; ^
COMMIT WORK;
SET AUTODDL ON;
SET TERM ^ ;


/* Triggers only will work for SQL triggers */

CREATE TRIGGER INC_TRIGGER1 FOR ACCOUNT 
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.acc_NO is NULL) then 
  NEW.acc_NO = GEN_ID(account_GEN, 1);
end
 ^

CREATE TRIGGER UP_TRIGGERACC FOR ACCOUNT 
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
  NEW.MUTDATE = 'NOW';
end
 ^

CREATE TRIGGER UP_TRIGGERACCTYPE FOR ACCTYPE 
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
  NEW.MUTDATE = 'NOW';
end
 ^

CREATE TRIGGER INC_TRIGGER FOR CUSTOMER 
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.CUST_NO is NULL) then 
  NEW.CUST_NO = GEN_ID(CUSTOMER_GEN, 1);
end
 ^

CREATE TRIGGER UP_TRIGGER FOR CUSTOMER 
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
  NEW.MUTDATE = 'NOW';
end
 ^

CREATE TRIGGER INC_KINGSTRIGGER FOR KINGS 
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
   /* if (new.kings_ID is NULL) then */ 
  NEW.kings_ID = GEN_ID(KINGS_GEN, 1);
END
 ^

CREATE TRIGGER UP_TRIGGERKINGS FOR KINGS 
ACTIVE AFTER UPDATE POSITION 0
AS
BEGIN
  NEW.MUTDATE = 'NOW';
end
 ^

CREATE TRIGGER INC_TRIG FOR TRANS 
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (new.trans_id is NULL) then 
  NEW.trans_id = GEN_ID(trans_GEN, 1);

END
 ^

CREATE TRIGGER TRANS1INC_TRIG FOR TRANS1 
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
if (new.trans_id is NULL) then 
  NEW.trans_id = GEN_ID(trans_GEN, 1);

END
 ^

CREATE TRIGGER INS_TRIGGERTRANS FOR TRANS1 
ACTIVE AFTER INSERT POSITION 0
AS
BEGIN
  if (new.Acc_NO is not NULL) then
        new.openPerson = USER;
end
 ^
COMMIT WORK ^
SET TERM ;^

/* Grant Roles for this database */

/* Grant permissions for this database */

GRANT EXECUTE ON PROCEDURE GETACCOUNTS TO SYSDBA;
GRANT EXECUTE ON PROCEDURE GETCUST_NO TO SYSDBA;
GRANT EXECUTE ON PROCEDURE SP_NEXT_ACCTYPE_ID TO SYSDBA;
GRANT EXECUTE ON PROCEDURE SP_NEXT_ACC_ID TO SYSDBA;
GRANT EXECUTE ON PROCEDURE SP_NEXT_CUST_ID TO SYSDBA;
GRANT EXECUTE ON PROCEDURE SP_NEXT_TRANS_ID TO SYSDBA;

/*COMMIT WORK ;*/
SET AUTODDL ON;

/*EXEC SQL*/
INSERT INTO CUSTOMER(CUST_NO, CUSTOMER, CONTACT_FIRST) VALUES (1001, 'Max the Rock', 'max@kleiner.com');
COMMIT WORK;

INSERT INTO ACCTYPE(ACC_ID, DESCRIPT) VALUES (4, 'Bank');
INSERT INTO ACCTYPE(ACC_ID, DESCRIPT) VALUES (5, 'Broker');
INSERT INTO ACCTYPE(ACC_ID, DESCRIPT) VALUES (6, 'Post');

COMMIT WORK;








